<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "product_element".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProductElement".
 *
 * Columns in table "product_element" available as properties of the model,
 * followed by relations of table "product_element" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property integer $product_element_category_id
 *
 * @property DataElementProductElement[] $dataElementProductElements
 * @property DataElementSourceConfidence[] $dataElementSourceConfidences
 * @property ProductElementCategory $productElementCategory
 */
abstract class BaseProductElement extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'product_element';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProductElement|ProductElements', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('id, name, product_element_category_id', 'required'),
            array('id, product_element_category_id', 'numerical', 'integerOnly'=>true),
            array('name', 'length', 'max'=>45),
            array('id, name, product_element_category_id', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'dataElementProductElements' => array(self::HAS_MANY, 'DataElementProductElement', 'product_element_id'),
            'dataElementSourceConfidences' => array(self::HAS_MANY, 'DataElementSourceConfidence', 'product_element_id'),
            'productElementCategory' => array(self::BELONGS_TO, 'ProductElementCategory', 'product_element_category_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'product_element_category_id' => null,
            'dataElementProductElements' => null,
            'dataElementSourceConfidences' => null,
            'productElementCategory' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('product_element_category_id', $this->product_element_category_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
